diff mbox

[2/9] perf build: Pass O option to Makefile.perf in build-test

Message ID 1452687442-6186-3-git-send-email-wangnan0@huawei.com
State Superseded
Headers show

Commit Message

Wang Nan Jan. 13, 2016, 12:17 p.m. UTC
Doesn't like tools/perf/Makefile, tools/perf/Makefile.perf obey 'O'
option when it is passed through cmdline only, because of code in
tools/scripts/Makefile.include:

 ifneq ($(O),)
 ifeq ($(origin O), command line)
 	...
 	ABSOLUTE_O := $(shell cd $(O) ; pwd)
 	OUTPUT := $(ABSOLUTE_O)/$(if $(subdir),$(subdir)/)
 endif
 endif

This patch passes 'O' to Makefile.perf through cmdline explicitly
to make it follow O variable during build-test.

Signed-off-by: Wang Nan <wangnan0@huawei.com>

Cc: Arnaldo Carvalho de Melo <acme@redhat.com>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Namhyung Kim <namhyung@kernel.org>
---
 tools/perf/tests/make | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

-- 
1.8.3.4

Comments

Wang Nan Jan. 14, 2016, 9:56 a.m. UTC | #1
On 2016/1/14 17:32, Jiri Olsa wrote:
> On Wed, Jan 13, 2016 at 12:17:15PM +0000, Wang Nan wrote:

>> Doesn't like tools/perf/Makefile, tools/perf/Makefile.perf obey 'O'

>> option when it is passed through cmdline only, because of code in

>> tools/scripts/Makefile.include:

>>

>>   ifneq ($(O),)

>>   ifeq ($(origin O), command line)

>>   	...

>>   	ABSOLUTE_O := $(shell cd $(O) ; pwd)

>>   	OUTPUT := $(ABSOLUTE_O)/$(if $(subdir),$(subdir)/)

>>   endif

>>   endif

>>

>> This patch passes 'O' to Makefile.perf through cmdline explicitly

>> to make it follow O variable during build-test.

>>

>> Signed-off-by: Wang Nan <wangnan0@huawei.com>

>> Cc: Arnaldo Carvalho de Melo <acme@redhat.com>

>> Cc: Jiri Olsa <jolsa@kernel.org>

>> Cc: Namhyung Kim <namhyung@kernel.org>

>> ---

>>   tools/perf/tests/make | 12 ++++++++++--

>>   1 file changed, 10 insertions(+), 2 deletions(-)

>>

>> diff --git a/tools/perf/tests/make b/tools/perf/tests/make

>> index c0ee679..14d7b8d 100644

>> --- a/tools/perf/tests/make

>> +++ b/tools/perf/tests/make

>> @@ -5,7 +5,7 @@ ifeq ($(MAKECMDGOALS),)

>>   # no target specified, trigger the whole suite

>>   all:

>>   	@echo "Testing Makefile";      $(MAKE) -sf tests/make MK=Makefile

>> -	@echo "Testing Makefile.perf"; $(MAKE) -sf tests/make MK=Makefile.perf SET_PARALLEL=1

>> +	@echo "Testing Makefile.perf"; $(MAKE) -sf tests/make MK=Makefile.perf SET_PARALLEL=1 SET_O=1

>>   else

>>   # run only specific test over 'Makefile'

>>   %:

>> @@ -13,6 +13,14 @@ else

>>   endif

>>   else

>>   PERF := .

>> +O_OPT :=

>> +

>> +ifneq ($(O),)

>> +  FULL_O := $(shell readlink -f $(O) || echo $(O))

>> +  ifeq ($(SET_O),1)

>> +    O_OPT := 'O=$(FULL_O)'

>> +  endif

>> +endif

>>   

>>   PARALLEL_OPT=

>>   ifeq ($(SET_PARALLEL),1)

>> @@ -261,7 +269,7 @@ clean := @(cd $(PERF); make -s -f $(MK) clean >/dev/null)

>>   $(run):

>>   	$(call clean)

>>   	@TMP_DEST=$$(mktemp -d); \

>> -	cmd="cd $(PERF) && make -f $(MK) $(PARALLEL_OPT) DESTDIR=$$TMP_DEST $($@)"; \

>> +	cmd="cd $(PERF) && make -f $(MK) $(PARALLEL_OPT) $(O_OPT) DESTDIR=$$TMP_DEST $($@)"; \

> hum, but this set is to test make without O=... so why would you set it?

> run_O is the target for O=... tests


I have strong motivation to avoid polluting source directory.

I have different platforms and sometime I want to build them
(cross-compile) parallelly. I use yocto for this. Yocto appends 'O'
automatically. This is good for building, but when I use the
framework for build-test I have to manually adjust the generated
scripts (and it would be regenerated again in next run) to make it
work, and also I'm unable to test them in parallel.

For people who don't care about this, $(O_OPT) is empty so he/she
still tests without 'O=...' case.

Thank you.
diff mbox

Patch

diff --git a/tools/perf/tests/make b/tools/perf/tests/make
index c0ee679..14d7b8d 100644
--- a/tools/perf/tests/make
+++ b/tools/perf/tests/make
@@ -5,7 +5,7 @@  ifeq ($(MAKECMDGOALS),)
 # no target specified, trigger the whole suite
 all:
 	@echo "Testing Makefile";      $(MAKE) -sf tests/make MK=Makefile
-	@echo "Testing Makefile.perf"; $(MAKE) -sf tests/make MK=Makefile.perf SET_PARALLEL=1
+	@echo "Testing Makefile.perf"; $(MAKE) -sf tests/make MK=Makefile.perf SET_PARALLEL=1 SET_O=1
 else
 # run only specific test over 'Makefile'
 %:
@@ -13,6 +13,14 @@  else
 endif
 else
 PERF := .
+O_OPT :=
+
+ifneq ($(O),)
+  FULL_O := $(shell readlink -f $(O) || echo $(O))
+  ifeq ($(SET_O),1)
+    O_OPT := 'O=$(FULL_O)'
+  endif
+endif
 
 PARALLEL_OPT=
 ifeq ($(SET_PARALLEL),1)
@@ -261,7 +269,7 @@  clean := @(cd $(PERF); make -s -f $(MK) clean >/dev/null)
 $(run):
 	$(call clean)
 	@TMP_DEST=$$(mktemp -d); \
-	cmd="cd $(PERF) && make -f $(MK) $(PARALLEL_OPT) DESTDIR=$$TMP_DEST $($@)"; \
+	cmd="cd $(PERF) && make -f $(MK) $(PARALLEL_OPT) $(O_OPT) DESTDIR=$$TMP_DEST $($@)"; \
 	echo "- $@: $$cmd" && echo $$cmd > $@ && \
 	( eval $$cmd ) >> $@ 2>&1; \
 	echo "  test: $(call test,$@)" >> $@ 2>&1; \